Agda-2.5.2: A dependently typed functional programming language and proof assistant

Safe Haskell | None
Language | Haskell2010

Agda.TypeChecking.EtaContract

Description

Compute eta short normal forms.

Synopsis

- data BinAppView
  - = App Term (Arg Term)
  - | NoApp Term
- binAppView :: Term -> BinAppView
- etaContract :: (MonadReader TCEnv m, HasConstInfo m, HasOptions m, TermLike a) => a -> m a
- etaOnce :: (MonadReader TCEnv m, HasConstInfo m, HasOptions m) => Term -> m Term

# Documentation

data BinAppView #

Constructors

App Term (Arg Term) |
NoApp Term |

binAppView :: Term -> BinAppView #

etaContract :: (MonadReader TCEnv m, HasConstInfo m, HasOptions m, TermLike a) => a -> m a #

Contracts all eta-redexes it sees without reducing.

etaOnce :: (MonadReader TCEnv m, HasConstInfo m, HasOptions m) => Term -> m Term #